import argparse
from subprocess import Popen
parser = argparse.ArgumentParser(description="Main entry point "
                                             "for offline calibration")
parser.add_argument("--input", type=str)
parser.add_argument("--output", type=str)
parser.add_argument("--base-cal-store", default="base", type=str)
parser.add_argument("--offset-cal-store", default="base", type=str)
parser.add_argument("--mem-cells", type=int)
parser.add_argument("--detector", type=str)
parser.add_argument("--sequences", type=str, default="All")
parser.add_argument("--overwrite", action="store_true")

args = vars(parser.parse_args())

in_folder = args["input"]
out_folder = args["output"]
base_store = args["base_cal_store"]
offset_store = args["offset_cal_store"]
mem_cells = args["mem_cells"]
detector = args["detector"]
sequences = args["sequences"]
overwrite = str(args["overwrite"])
if detector.upper() not in ["AGIPD"]:
    raise AttributeError("Unknown detector: {}".format(detector))

if base_store == "base":
    if detector.upper() == "AGIPD":
        base_store = "/gpfs/exfel/data/user/haufs/scripted_offline_cal/calstore/agipd_base_cal.h5"
if offset_store == "base":
    if detector.upper() == "AGIPD":
        offset_store = "/gpfs/exfel/data/user/haufs/scripted_offline_cal/calstore/agipd_offset_cal.h5"

if detector.upper() == "AGIPD":
    script = "AGIPD/correct_agipd_batch.py"
cmd = ["python", script, in_folder, out_folder, base_store, offset_store, str(mem_cells), sequences, overwrite]
Popen(cmd).wait()
